<!--车辆列表-->
<template>
  <div class="app-container">
    <!--筛选条件-->
    <div class="search-div">
      <div class="search-left">
        <el-form ref="selectForm" :inline="true" :model="listQuery" class="form-container">
          <el-row>
            <el-col :span="5">
              <el-form-item class="selectForm-container-item">
                <el-input v-model.trim="listQuery.keywords" placeholder="车牌号/车主姓名" clearable />
              </el-form-item>
            </el-col>
            <el-col :span="5">
              <el-form-item class="selectForm-container-item">
                <el-select v-model="listQuery.property" placeholder="请选择车辆性质" clearable>
                  <el-option v-for="item in carProperties" :key="item.value" :label="item.name" :value="item.value"/>
                </el-select>
              </el-form-item>
            </el-col>

            <el-col :span="6" class="search-right">
              <el-button class="filter-item" type="primary" icon="el-icon-search" @click="search">搜索</el-button>
            </el-col>
          </el-row>
        </el-form>
      </div>
    </div>
    <!--查询结果Table显示-->
    <div>
      <el-row class="table-title">
        <el-col :span="6"><div class="title-header"><i class="el-icon-menu"/>数据列表</div></el-col>
        <el-col :span="12" :offset="6" class="edit_btns">
          <el-button class="edit_btn" size="small" @click="batchExport" :disabled="list.length===0">导出</el-button>
          <el-button v-if="hasPerm('/door/car/add')" class="edit_btn" size="small" @click="add">新增</el-button>
          <!--          <el-button v-if="hasPerm('/door/car/delete')" v-show="false" class="edit_btn" size="small" @click="batchDel">删除</el-button>-->
        </el-col>
      </el-row>
      <el-table v-loading="listLoading" :data="list" class="table" row-class-name="small-row-class" border @selection-change="handleSelectionChange">
        <!--拥有删除权限则显示复选框-->
        <!--        <el-table-column v-if="hasPerm('/staff/delete')" align="center" type="selection" width="55"/>-->
        <!--序号列-->
        <el-table-column :index="indexMethod" align="center" type="index" label="#" width="55"/>
        <!--内容列-->
        <el-table-column v-for="column in columns" :key="column.value" :label="column.text" :width="column.width" :align="column.align" show-overflow-tooltip>
          <template slot-scope="scope">
            <span :class="column.class">{{ scope.row[column.value] }}</span>
          </template>
        </el-table-column>
        <!--操作列-->
        <el-table-column label="操作" align="center" width="160">
          <template slot-scope="scope">
            <el-button type="text" @click="detail(scope.row)">详情</el-button>
            <el-button v-if="hasPerm('/door/car/update')" type="text" @click="edit(scope.row)">编辑</el-button>
            <el-button v-if="hasPerm('/door/car/delete')" type="text" @click="del(scope.row.id)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <!--分页-->
    <div class="pagination-container">
      <el-pagination
        v-show="total>listQuery.limit"
        :current-page="listQuery.offset"
        :page-sizes="[20,30,50]"
        :page-size="listQuery.limit"
        :total="total"
        align="center"
        layout="total, sizes, prev, pager, next"
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"/>
    </div>
    <car-add ref="carAdd" @watchChild="fetchData"/>
  </div>
</template>

<script>
import CarAdd from '@/views/car/carAdd'
import { getCarList, deleteCar } from '@/api/car'
import { getCarProperty } from '@/api/allDict'
import { carExport } from '@/api/batch'

export default {
  name: 'CarList',
  components: { CarAdd },
  data() {
    return {
      listQuery: {
        keywords: '',
        property: '',
        offset: 1,
        limit: 20,
        sort: '',
        order: ''
      }, // 筛选条件
      columns: [
        {
          text: '车牌号',
          value: 'plateNumber',
          align: 'center',
          width: 140
        },
        {
          text: '车辆性质',
          value: 'propertyStr',
          align: 'center'
        },
        // {
        //   text: '车主姓名',
        //   value: 'ownerName',
        //   align: 'center'
        // },
        {
          text: '车主联系电话',
          value: 'phone',
          align: 'center'
        }
      ], // 显示列
      list: [], // 列表数据
      total: 0, // 数据总数
      multipleSelection: [], // 多选选中项
      carProperties: [],
      listLoading: false, // 加载动画
      fullscreenLoading: false, // 全屏加载动画
      dialogFormVisible: false
    }
  },
  created() {
    this.fetchCarPropertiesData()
  },
  activated() {
    this.fetchData() // 获取数据
  },
  methods: {
    batchExport() {
      // 全屏加载动画
      const loading = this.$loading({
        lock: true,
        text: '下载中,请稍后...',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })
      carExport(this.listQuery).then(res => {
        loading.close() // 关闭加载动画
        console.log('download===', res)
        const blob = new Blob([res.data])
        const downloadElement = document.createElement('a')
        const href = window.URL.createObjectURL(blob) // 创建下载的链接
        downloadElement.href = href
        downloadElement.download = `车辆列表.xlsx` // 下载后文件名
        document.body.appendChild(downloadElement)
        downloadElement.click() // 点击下载
        document.body.removeChild(downloadElement) // 下载完成移除元素
        window.URL.revokeObjectURL(href) // 释放blob对象
      }).catch((res) => {
        loading.close()
        this.$message.error(res.message)
      })
    },
    // 检查选择情况
    checkSelection() {
      if (this.multipleSelection.length === 0) {
        return false
      } else {
        return true
      }
    },
    // 编辑设备信息
    detail(row) {
      this.dialogFormVisible = true
      this.$refs.carAdd.initDialog('detail', this.dialogFormVisible, row)
    },
    add() {
      this.dialogFormVisible = true
      this.$refs.carAdd.initDialog('create', this.dialogFormVisible)
    },
    // 编辑设备信息
    edit(row) {
      this.dialogFormVisible = true
      this.$refs.carAdd.initDialog('update', this.dialogFormVisible, row)
    },
    // 删除设备
    del(id) {
      this.$confirm(
        '确定要删除所选车辆吗？',
        '确认操作',
        {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }
      ).then(() => {
        deleteCar(id).then(response => {
          if (response.code === 200) {
            this.$message.success('删除成功')
            this.fetchData()
          }
        })
      })
    },
    batchDel() {

    },
    // 查询数据
    search() {
      this.fetchData(false)
    },
    fetchCarPropertiesData() {
      getCarProperty().then(response => {
        this.carProperties = response.data
      })
    },
    // 获取列表
    fetchData(isNowPage = true) {
      this.listLoading = true
      if (!isNowPage) { // 是否显示当前页，否则跳转第一页
        this.listQuery.offset = 1
      }
      getCarList(this.listQuery).then(response => {
        if (response.code === 200) {
          this.list = response.data.rows
          this.total = parseInt(response.data.total)
        } else {
          this.$message.error(response.message)
        }
        this.listLoading = false
      })
    },
    indexMethod(index) {
      return this.listQuery.limit * (this.listQuery.offset - 1) + index + 1
    },
    // 改变页容量
    handleSizeChange(val) {
      this.listQuery.limit = val
      this.fetchData()
    },
    // 改变当前页
    handleCurrentChange(val) {
      this.listQuery.offset = val
      this.fetchData()
    },
    // 多选触发方法
    handleSelectionChange(val) {
      this.multipleSelection = val
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  $tableTitleHeight:46px;
  .app-container{
    margin-bottom:20px
  }
  .table{
    margin-bottom: 20px;
  }
  .pagination-container{
    margin-bottom: 50px;
  }
  .table-title{
    background-color:rgba(243, 243, 243, 1);
    height: $tableTitleHeight;
    .title-header{
      line-height:$tableTitleHeight;
      color: #606266;
      font-size: 15px;
      i{
        margin-left: 5px;
        margin-right: 5px;
      }
    }
  }
  .edit_btns{
    .edit_btn{
      float:right;
      margin:7px 3px;//为了需要居中显示margin-top和bottom要用$tableTitleHeight减去按钮原高度除以2
    }
  }
</style>
